image:
  name: registry.gitlab.com/gitlab-org/terraform-images/releases/terraform:1.0.3

variables:
  TF_ROOT: ${CI_PROJECT_DIR}  # The relative path to the root directory of the Terraform project
  TF_STATE_NAME: default
  TF_HTTP_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/${TF_STATE_NAME}
  TF_HTTP_USERNAME: gitlab-ci-token
  TF_HTTP_PASSWORD: ${CI_JOB_TOKEN}

cache:
  key: "${TF_STATE_NAME}"
  paths:
    - ${TF_ROOT}/.terraform/

before_script:
  - cd ${TF_ROOT}

workflow:
  rules: 
    - if: $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /^infrastructure/
      variables: 
        TF_VAR_test_gitlab_ci_tfvar: "dev"
    - if: $CI_COMMIT_BRANCH =~ /^release/
      variables: 
        TF_VAR_test_gitlab_ci_tfvar: "production"
    - if: $CI_COMMIT_BRANCH =~ /^main/
      variables: 
        TF_VAR_test_gitlab_ci_tfvar: "DELETE"

stages:
  - init
  - validate
  - plan
  - apply
  - destroy

init:
  stage: init
  script:
    - gitlab-terraform init -input=false -reconfigure -backend-config="address=${TF_HTTP_ADDRESS}" 
        

validate:
  stage: validate
  script:
    - gitlab-terraform fmt -check -recursive 
  dependencies:
    - init
  allow_failure: true

test:
  image: 
    name: openpolicyagent/conftest
    entrypoint: ["/bin/sh", "-c"]
  stage: validate
  script:
    - conftest test main.tf
  allow_failure: false

plan:
  stage: plan
  script:
    - gitlab-terraform plan 
    - gitlab-terraform plan-json 
  resource_group: ${TF_STATE_NAME}
  artifacts:
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json
  dependencies:
    - validate

apply:
  stage: apply
  script:
    - gitlab-terraform apply 
  resource_group: ${TF_STATE_NAME}
  when: manual
  only:
    variables:
      - $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  dependencies:
    - plan

destroy:
  stage: destroy
  script:
    - gitlab-terraform destroy 
  resource_group: ${TF_STATE_NAME}
  when: manual
  dependencies:
    - apply

